package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.base.Preconditions;
import com.google.common.collect.ImmutableSet;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.tags.DamageTypeTags;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;

public class MageSlayerBonus extends GemBonus {
  public static Codec<dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.MageSlayerBonus> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.MageSlayerBonus::new));
  }
  
  public MageSlayerBonus(Map<LootRarity, StepFunction> values) {
    super(Apotheosis.loc("mageslayer"), new GemClass("helmet", ImmutableSet.of(LootCategory.HELMET)));
    this.values = values;
  }
  
  public float onHurt(ItemStack gem, LootRarity rarity, DamageSource src, LivingEntity user, float amount) {
    float value = ((StepFunction)this.values.get(rarity)).min();
    if (src.m_269533_(DamageTypeTags.f_268490_)) {
      user.m_5634_(amount * value);
      return amount * (1.0F - value);
    } 
    return super.onHurt(gem, rarity, src, user, amount);
  }
  
  public Codec<? extends GemBonus> getCodec() {
    return (Codec)CODEC;
  }
  
  public Component getSocketBonusTooltip(ItemStack gem, LootRarity rarity) {
    float value = ((StepFunction)this.values.get(rarity)).min();
    return (Component)Component.m_237110_("bonus." + getId() + ".desc", new Object[] { Affix.fmt(value * 100.0F) }).m_130940_(ChatFormatting.YELLOW);
  }
  
  public dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.MageSlayerBonus validate() {
    Preconditions.checkNotNull(this.values);
    this.values.forEach((k, v) -> {
          Preconditions.checkNotNull(k);
          Preconditions.checkNotNull(v);
        });
    return this;
  }
  
  public boolean supports(LootRarity rarity) {
    return this.values.containsKey(rarity);
  }
  
  public int getNumberOfUUIDs() {
    return 0;
  }
}
